Package net.sf.saxon.event

## Class Valve

- java.lang.Object
- - net.sf.saxon.event.SequenceReceiver
  - - net.sf.saxon.event.ProxyReceiver
    - - net.sf.saxon.event.Valve

- All Implemented Interfaces:
    `javax.xml.transform.Result`, `Receiver`

      public class Valve
      extends ProxyReceiver

  A Valve is a general-purpose component for use in a pipeline of receivers. It selects an alternative destination for the pipeline events based on the namespace of the first startElement event. There is a primary destination which is selected initially. If the namespace of the first element has a given value, then subsequent output is sent to an alternative destination.

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.event.ProxyReceiver

      `nextReceiver`

    - ### Fields inherited from class net.sf.saxon.event.SequenceReceiver

      `pipelineConfiguration, previousAtomic, systemId`

    - ### Fields inherited from interface javax.xml.transform.Result

      `PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Valve​(java.lang.String testNamespace, Receiver primary, Receiver secondary)` | Create a `Valve`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `startElement​(NodeName elemName, SchemaType type, AttributeMap attributes, NamespaceMap namespaces, Location location, int properties)` | Notify the start of an element
    `boolean` | `wasDiverted()` | Ask (after the first element event has been received) whether output was diverted to the secondary receiver

    - ### Methods inherited from class net.sf.saxon.event.ProxyReceiver

      `append, characters, close, comment, endDocument, endElement, getNamePool, getNextReceiver, open, processingInstruction, setPipelineConfiguration, setSystemId, setUnderlyingReceiver, setUnparsedEntity, startDocument, usesTypeAnnotations`

    - ### Methods inherited from class net.sf.saxon.event.SequenceReceiver

      `append, decompose, flatten, getConfiguration, getErrorCodeForDecomposingFunctionItems, getPipelineConfiguration, getSystemId, handlesAppend`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Valve

          public Valve​(java.lang.String testNamespace,
                       Receiver primary,
                       Receiver secondary)

      Create a `Valve`. Events sent to this `Valve` will be forwarded to the primary receiver, unless the namespace of the first element node matches the test namespace, in which case the events will be forwarded to the secondary receiver
      Parameters:
        `testNamespace` - the test namespace
        `primary` - the primary Receiver
        `secondary` - the secondary Receiver

  - ### Method Detail

    - #### startElement

          public void startElement​(NodeName elemName,
                                   SchemaType type,
                                   AttributeMap attributes,
                                   NamespaceMap namespaces,
                                   Location location,
                                   int properties)
                            throws XPathException

      Description copied from class: `ProxyReceiver`
      Notify the start of an element
      Specified by:
        `startElement` in interface `Receiver`
      Overrides:
        `startElement` in class `ProxyReceiver`
      Parameters:
        `elemName` - the name of the element.
        `type` - the type annotation of the element.
        `attributes` - the attributes of this element
        `namespaces` - the in-scope namespaces of this element: generally this is all the in-scope namespaces, without relying on inheriting namespaces from parent elements
        `location` - an object providing information about the module, line, and column where the node originated
        `properties` - bit-significant properties of the element node. If there are no relevant properties, zero is supplied. The definitions of the bits are in class `ReceiverOption`
      Throws:
        `XPathException` - if an error occurs

    - #### wasDiverted

          public boolean wasDiverted()

      Ask (after the first element event has been received) whether output was diverted to the secondary receiver
      Returns:
        true if output was diverted, that is, if the first element node was in the test namespace.